package com.lsf.cmd;

import javax.servlet.http.HttpServletRequest;

import com.octo.captcha.service.CaptchaServiceException;
import com.octo.captcha.service.image.DefaultManageableImageCaptchaService;
import com.octo.captcha.service.image.ImageCaptchaService;


public class CaptchaServiceSingleton {

	private static ImageCaptchaService instance = new DefaultManageableImageCaptchaService();

	public static ImageCaptchaService getInstance() {
		return instance;
	}
	
	public static boolean isValidation(HttpServletRequest request, String value) {
		Boolean isResponseCorrect = Boolean.FALSE;
		//remenber that we need an id to validate!
		String captchaId = request.getSession().getId();
		//retrieve the response
		String res = value;
		// Call the Service method
		try {
			isResponseCorrect = CaptchaServiceSingleton.getInstance()
			.validateResponseForID(captchaId, res);
		} catch (CaptchaServiceException e) {
			return false;
		}
		return Boolean.getBoolean(isResponseCorrect+"");
	}
}
