package com.lsf.db;

import java.io.File;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import com.lsf.util.CommonMap;

public class DBConf extends HashMap {
	private static DBConf me = null;

	private String baseRepository;

	private DBConf() {
		baseRepository = CommonMap.getValue("/prj/conf/jdbcConfFile");
	}

	public synchronized static DBConf getInstance() {
		if (me == null)
			me = new DBConf();
		return me;
	}

	public static String getValue(String id) {
		DBConf map = getInstance();
		String cls = null;
		cls = map.readFromHash(id);
		if (cls != null)
			return cls;

		cls = map.readFromFile(id);
		
		return cls;
	}

	private String readFromFile(String id) {
		String result = null;

		Node n;

		try {
			n = findNode(id);
			if (n != null)
				result = n.getFirstChild().getNodeValue();
		} catch (Exception e) {
		}

		if (result != null) {
			this.put(id, result);
		}

		return result;
	}

	protected Node findNode(String id) throws Exception {
		id = "/jdbc/" + id;

		String dir = baseRepository;

		String[] key = id.split("/");

		File f = new File(dir);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setIgnoringElementContentWhitespace(true);
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(f);
		Node node = document;
		for (int i = 0; i < key.length; i++)
			if (!key[i].equals("")) {
				node = findNode(node, key[i]);
				if (node == null) return null;
			}

		if (node.equals(document))
			return null;
		else
			return node;
	}

	private Node findNode(Node parent, String id) {
		Node result = null;
		for (Node n = parent.getFirstChild(); n != null; n = n.getNextSibling()) {
			if (n.getNodeType() != Node.ELEMENT_NODE)
				continue;

			if (n.getNodeName().equals(id))
				result = n;
		}
		return result;
	}

	private String readFromHash(String id) {
		return (String) this.get(id);
	}

	public void resourceRefresh() {
		this.clear();
	}
}
