package com.lsf.db;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

import com.lsf.util.CommonMap;

public class Sql extends HashMap {
	private static Sql me = null;

	private boolean dynamicLoad = false;

	private String baseRepository;

	private Sql() {
		baseRepository = CommonMap.getValue("/prj/conf/sqlDir");
		dynamicLoad = Boolean.valueOf(CommonMap.getValue("/prj/conf/sqlAutoReload")).booleanValue();
	}

	public static Sql getInstance() {
		if (me == null)
			me = new Sql();
		return me;
	}

	public static String getSql(String id) {
		Sql sql = getInstance();
		String query = null;
		if (!sql.dynamicLoad) {
			query = sql.readFromHash(id);
			if (query != null)
				return query;
		}

		try {
			query = sql.readFromFile(id);
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return query;
	}

	private String readFromFile(String id) throws ParserConfigurationException,
			SAXException, IOException {
		String result = null;

		String[] ids = id.split("/");
		String dir = baseRepository;

		if (ids.length == 1)
			dir += File.separator+"default";

		for (int i = 0; i < ids.length - 1; i++) {
			dir += File.separator + ids[i];
		}
		dir += ".xml";

		String key = ids[ids.length - 1];

		File f = new File(dir);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setIgnoringElementContentWhitespace(true);
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(f);
		Node root = document.getFirstChild();
		if (root.getNodeName().toLowerCase().equals("statements")) {
			for (Node n = root.getFirstChild(); n != null; n = n
					.getNextSibling()) {
				if (n.getNodeType() != Node.ELEMENT_NODE)
					continue;

				NamedNodeMap map = n.getAttributes();
				if (n.getNodeName().toLowerCase().equals("statement"))
					if (key.equals(map.getNamedItem("id").getNodeValue())) {
						Node child =  n.getFirstChild();
						if (child.getNodeType() == Node.TEXT_NODE)
							result = child.getNodeValue();
						else if (child.getNodeType() == Node.CDATA_SECTION_NODE)
							result = child.getNodeValue();
					}
			}
		}

		if (result != null) {
			this.put(id, result);
		}

		return result;
	}

	private String readFromHash(String id) {
		return (String) this.get(id);
	}

	public void resourceRefresh() {
		this.clear();
	}
}
