package com.lsf.servlet;

import java.io.IOException;
import java.io.PrintWriter;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.lsf.cmd.AbstractCmd;
import com.lsf.util.CommonMap;
import com.lsf.util.NavigationMap;

public class DefaultChannelServlet extends HttpServlet {

	protected void service(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException {
		String[] tempUrl = req.getRequestURI().split("/");
		String key = tempUrl[tempUrl.length-1];

		String extension = "";
		try {
			InitialContext ctx = new InitialContext();
			extension = (java.lang.String) ctx.lookup("java:comp/env/extension");
		} catch (NamingException e) {
			e.printStackTrace();
		}

		key = key.replaceAll("."+extension, "");

		String className = NavigationMap.getClass(key);
		try {
			AbstractCmd cmd = (AbstractCmd)Class.forName(className).newInstance();
			cmd.service(req, res);
		} catch (Exception e) {
			System.out.println(req.getRequestURI() + " : " + className);
			e.printStackTrace();
			e.printStackTrace(getOutputStream(res));
			throw new ServletException(e);
		}
	}

	protected PrintWriter getOutputStream(HttpServletResponse res) throws IOException {
		res.setContentType("text/html; charset="+CommonMap.getValue("/prj/conf/encoding"));
		PrintWriter out = res.getWriter();
		res.setHeader("Pragma", "No-cache");
		res.setHeader("Cache-Control", "No-cache");
		res.setHeader("Expires", "1");

		return out;
	}
}
