package com.lsf.support;

import java.util.ArrayList;

/**
 * Data ArrayList
 * @author õȣ
 */
public class MultiData extends ArrayList {
	private boolean init = false;

	private String name;

	public MultiData() {
		super();
	}

	public MultiData(String name) {
		super();
		this.name = name;
	}

	public void addData(Data data) {
		this.add(data);
	}

	public Data getData(int i) {
		return (Data)this.get(i);
	}

	public void setNullToInitialize(boolean b) {
		this.init = b;
	}

	public byte getByte(String key, int i) {
		Data data = this.getData(i);
		return data.getByte(key);
	}

	public String getString(String key, int i) {
		Data data = this.getData(i);
		data.setNullToInitialize(this.init);
		return data.getString(key);
	}

	public int getInt(String key, int i) {
		Data data = this.getData(i);
		return data.getInt(key);
	}

	public float getFloat(String key, int i) {
		Data data = this.getData(i);
		return data.getFloat(key);
	}

	public long getLong(String key, int i) {
		Data data = this.getData(i);
		return data.getInt(key);
	}

	public short getShort(String key, int i) {
		Data data = this.getData(i);
		return data.getShort(key);
	}

	public double getDouble(String key, int i) {
		Data data = this.getData(i);
		return data.getDouble(key);
	}

	public String[] getStringArray(String key, int i) {
		Data data = this.getData(i);
		data.setNullToInitialize(this.init);
		return data.getStringArray(key);
	}

	public Object getObject(String key, int i) {
		Data data = this.getData(i);
		data.setNullToInitialize(this.init);
		return data.get(key);
	}

	public String toString() {
		return "[MultiData : ("+this.name+")]="+super.toString();
	}

}

