package com.lsf.util;

import java.io.IOException;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.io.IOUtils;

import com.lsf.support.Data;
import com.lsf.support.HttpMultipartRequest;
import com.lsf.support.MultiData;

public class CollectionUtility {

	public static void setBean(Object o, HttpServletRequest req) {
		Method[] methods = o.getClass().getMethods();
		Data data = getData(req);
		String[] keys = data.getKeys();

		for (int i=0; i<keys.length; i++) {
			for (int j=0; j<methods.length; j++) {
				String compareMethosName = "set"+keys[i].substring(0,1).toUpperCase()+keys[i].substring(1);
				if (methods[j].getName().equals(compareMethosName)) {
					if (methods[j].getParameterTypes().length != 1)
						continue;

					Class type = methods[j].getParameterTypes()[0];

					Object[] params = new Object[1];

					if (type.getName().equals(byte.class.getName()))
						params[0] =  new Byte(data.getByte(keys[i]));
					else if (type.getName().equals(int.class.getName()))
						params[0] =  new Integer(data.getInt(keys[i]));
					else if (type.getName().equals(long.class.getName()))
						params[0] =  new Long(data.getLong(keys[i]));
					else if (type.getName().equals(float.class.getName()))
						params[0] =  new Float(data.getFloat(keys[i]));
					else if (type.getName().equals(double.class.getName()))
						params[0] =  new Double(data.getDouble(keys[i]));
					else if (type.getName().equals(short.class.getName()))
						params[0] =  new Short(data.getShort(keys[i]));
					else if (type.getName().equals(String.class.getName()))
						params[0] =  new String(data.getString(keys[i]));

					try {
						methods[j].invoke(o, params);
					} catch (IllegalArgumentException e) {
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						e.printStackTrace();
					} catch (InvocationTargetException e) {
						e.printStackTrace();
					}

				}
			}
		}
	}

	public static Data getData(HttpServletRequest req) {
		Map map = req.getParameterMap();
		Data data = new Data("REQ");
		Object[] keys = map.keySet().toArray();
		for (int i = 0; i < keys.length; i++) {
			String[] values = req.getParameterValues((String) keys[i]);
			if (values.length == 1)
				data.setString((String)keys[i], values[0]);
			else
				data.setStringArray((String)keys[i], values);
		}

		data.setString("clientIp", req.getRemoteAddr());

		if (req.getSession().getAttribute("user")!=null)
			setUserData(req, data);
		
		data.setString("sessionId", req.getSession().getId());

		return data;
	}

	public static Data getMultipartData(HttpMultipartRequest req) throws UnsupportedEncodingException {
		Data data = getData(req);

		if (req.fileItemList != null)
		for (int i=0; i<req.fileItemList.size(); i++) {
			FileItem item = (FileItem)req.fileItemList.get(i);
			if (item.getContentType() == null) {
				String key = item.getFieldName();
				if (!data.containsKey(key))
					data.setString(key, item.getString(CommonMap.getValue("/prj/conf/encoding")));
				else {
					Object o = data.get(key);
					if (o.getClass().getSimpleName().equals("String")) {
						String[] arr = new String[2];
						arr[0] = (String) o;
						arr[1] = item.getString(CommonMap.getValue("/prj/conf/encoding"));
						data.put(key, arr);
					} else {
						String[] src = (String[]) o;
						String[] dest = new String[src.length + 1];
						System.arraycopy(src, 0, dest, 0, src.length);
						dest[src.length] = item.getString(CommonMap.getValue("/prj/conf/encoding"));
						data.put(key, dest);
					}
				}
					
			}
		}

		return data;
	}

	public static MultiData getMultipartFiles(HttpMultipartRequest req) throws IOException {
		MultiData mData = new MultiData();

		if (req.fileItemList != null)
		for (int i=0; i<req.fileItemList.size(); i++) {
			FileItem item = (FileItem)req.fileItemList.get(i);
			if (item.getContentType() != null) {
				if (CommonUtil.nvl(item.getName()).length() == 0) continue;
				Data data = new Data();
				data.setString("fieldName", item.getFieldName());
				data.setString("contentType", item.getContentType());
				data.setString("name", item.getName());

				String clientPath = item.getName();
				clientPath = clientPath.replaceAll("\\\\", "/");
				String[] tempPath = clientPath.split("\\/");
				data.setString("fileName", tempPath[tempPath.length-1]);
				data.setString("clientPath", clientPath);

				data.setLong("size", item.getSize());
				data.put("inputStream", item.getInputStream());

				mData.addData(data);
			}
		}

		return mData;
	}

	private static void setUserData(HttpServletRequest req, Data data) {
		Data userData = (Data)req.getSession().getAttribute("user");

		String[] keys = userData.getKeys();
		for (int i=0; i<keys.length; i++)
			data.setString(keys[i], userData.getString(keys[i]));
	}

	public static MultiData getMultiData(ResultSet rs) throws SQLException {
		rs.last();
		int rowCount = rs.getRow();
		rs.beforeFirst();
		return getMultiData(rs, 0, rowCount);
	}

	public static Data getData(ResultSet rs) throws SQLException {
		ResultSetMetaData rsmd = rs.getMetaData();
		Data data = new Data();
		if (rs.next()) {
			for (int j = 1; j <= rsmd.getColumnCount(); j++) {
				Object o = rs.getObject(j);

				String columnClassName = rsmd.getColumnClassName(j);
				if (columnClassName.indexOf("Integer") >= 0)
					o = new Integer(rs.getInt(j));
				else if (columnClassName.indexOf("BigDecimal") >= 0)
					o = new Long(rs.getLong(j));
				else if (columnClassName.indexOf("BigInt") >= 0)
					o = new Long(rs.getLong(j));
				else if (columnClassName.indexOf("Long") >= 0)
					o = new Long(rs.getLong(j));
				else if (columnClassName.indexOf("Short") >= 0)
					o = new Long(rs.getShort(j));
				else if (columnClassName.indexOf("Boolean") >= 0)
					o = new Boolean(rs.getBoolean(j));
				else if (columnClassName.indexOf("Double") >= 0)
					o = new Double(rs.getDouble(j));
				else if (columnClassName.indexOf("Float") >= 0)
					o = new Float(rs.getFloat(j));
				else if (columnClassName.indexOf("String") >= 0)
					o = rs.getString(j);
				else if (columnClassName.toLowerCase().indexOf("clob") >= 0){
					try {
						Reader reader = rs.getClob(j).getCharacterStream();
						char[] c = IOUtils.toCharArray(reader);
						o = new StringBuffer().append(c).toString();
						reader.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
				else
					o = rs.getObject(j);

				data.put(rsmd.getColumnName(j).toLowerCase(), o);
			}
		}
		return data;
	}

	public static MultiData getMultiData(ResultSet rs, int start, int count)
			throws SQLException {
		MultiData mData = new MultiData("RESULTSET");
		ResultSetMetaData rsmd = rs.getMetaData();

		if (start > 1)
			rs.absolute(start);
		else
			rs.beforeFirst();

		for (int i = 1; i <= count; i++)
			if (rs.next()) {
				Data data = new Data(new StringBuffer().append(rs.getRow()).toString());
				for (int j = 1; j <= rsmd.getColumnCount(); j++) {
					Object o = rs.getObject(j);

					String columnClassName = rsmd.getColumnClassName(j);
					if (columnClassName.indexOf("Integer") >= 0)
						o = new Integer(rs.getInt(j));
					else if (columnClassName.indexOf("Long") >= 0)
						o = new Long(rs.getLong(j));
					else if (columnClassName.indexOf("Short") >= 0)
						o = new Long(rs.getShort(j));
					else if (columnClassName.indexOf("Boolean") >= 0)
						o = new Boolean(rs.getBoolean(j));
					else if (columnClassName.indexOf("Double") >= 0)
						o = new Double(rs.getDouble(j));
					else if (columnClassName.indexOf("Float") >= 0)
						o = new Float(rs.getFloat(j));
					else if (columnClassName.indexOf("String") >= 0)
						o = rs.getString(j);
					else if (columnClassName.toLowerCase().indexOf("clob") >= 0){
						try {
							Reader reader = rs.getClob(j).getCharacterStream();
							char[] c = IOUtils.toCharArray(reader);
							o = new StringBuffer().append(c).toString();
							reader.close();
						} catch (IOException e) {
							e.printStackTrace();
						}
					}
					else
						o = rs.getObject(j);

					data.put(rsmd.getColumnName(j).toLowerCase(), o);
				}
				mData.addData(data);
			}
		return mData;
	}
}
